%{!?python_sitearch: %define python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: Next generation package handling tool
Name: smart
Version: 0.42
Release: 34%{?dist}
License: GPL
Group: Applications/System
URL: http://labix.org/smart/
Source0: http://labix.org/download/smart/%{name}-%{version}.tar.bz2
Source1: smart.console
Source2: smart.pam
Source3: smart.desktop
Source4: distro.py
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: python-devel >= 2.3
BuildRequires: desktop-file-utils
Requires: python-abi = %(python -c "import sys ; print sys.version[:3]")
Requires: rpm-python >= 4.4
Requires: smart-config

%description
Smart Package Manager is a next generation package handling tool.

%package update
Summary: Allows execution of 'smart update' by normal users (suid)
Group: Applications/System
Requires: smart = %{version}-%{release}

%description update
Allows execution of 'smart update' by normal users through a
special suid command.

%package gui
Summary: Graphical user interface for the smart package manager
Group: Applications/System
Requires: smart = %{version}-%{release}
Requires: pygtk2 >= 2.4
Requires: usermode

%description gui
Graphical user interface for the smart package manager.

%prep
%setup -q
# /usr/lib is hardcoded 
perl -pi -e's,/usr/lib/,%{_libdir}/,' smart/const.py

%build
CFLAGS="%{optflags}"
export CFLAGS
python setup.py build

make -C contrib/smart-update

%install
rm -rf %{buildroot}
python setup.py install -O1 --root=%{buildroot}

mkdir -p %{buildroot}%{_libdir}/smart/plugins
mkdir -p %{buildroot}%{_sysconfdir}/smart/channels
mkdir -p %{buildroot}%{_localstatedir}/lib/smart{/packages,/channels}

# usermode support
ln -sf consolehelper %{buildroot}%{_bindir}/smart-root

mkdir -p %{buildroot}/etc/security/console.apps
mkdir -p %{buildroot}/etc/pam.d
install -p -m 644 %{SOURCE1} %{buildroot}/etc/security/console.apps/smart-root
install -p -m 644 %{SOURCE2} %{buildroot}/etc/pam.d/smart-root

# smart-update
install -p contrib/smart-update/smart-update %{buildroot}%{_bindir}

mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install --vendor fedora                            \
        --dir %{buildroot}%{_datadir}/applications              \
        --add-category X-Fedora                                 \
        %{SOURCE3}

mkdir -p  %{buildroot}%{_datadir}/pixmaps
install -p -m 644 smart/interfaces/images/smart.png \
    %{buildroot}%{_datadir}/pixmaps/smart.png

# distro.py and distro.d support
install -p -m 644 %{SOURCE4} %{buildroot}%{_libdir}/smart/
mkdir -p %{buildroot}%{_sysconfdir}/smart/distro.d

%find_lang %{name}

# Create a list w/o smart/interfaces/gtk to avoid warbing of duplicate
# in the %files section (otherwise including all and %excluding works,
# too

echo "%%defattr(-,root,root,-)" > %{name}.fileslist
find %{buildroot}%{python_sitearch}/smart -type d \
  | grep -v %{python_sitearch}/smart/interfaces/gtk \
  | sed -e's,%{buildroot},%%dir ,' \
  >> %{name}.fileslist
find %{buildroot}%{python_sitearch}/smart \! -type d \! -name \*.pyo \
  | grep -v %{python_sitearch}/smart/interfaces/gtk \
  | sed -e's,%{buildroot},,' \
  >> %{name}.fileslist
find %{buildroot}%{python_sitearch}/smart -name \*.pyo \
  | grep -v %{python_sitearch}/smart/interfaces/gtk \
  | sed -e's,%{buildroot},%%ghost ,' \
  >> %{name}.fileslist

# %files does not take two -f arguments
cat %{name}.lang >> %{name}.fileslist

%clean
rm -rf %{buildroot}

%files -f %{name}.fileslist
%defattr(-,root,root,-)
%doc HACKING README LICENSE TODO IDEAS
%{_bindir}/smart
%{_libdir}/smart
%{_sysconfdir}/smart
%{_localstatedir}/lib/smart
%{_mandir}/man8/smart.8*

%files update
%defattr(-,root,root,-)
%{_bindir}/smart-update

%files gui
%defattr(-,root,root,-)
%dir %{python_sitearch}/smart/interfaces/gtk
%{python_sitearch}/smart/interfaces/gtk/*.py
%{python_sitearch}/smart/interfaces/gtk/*.pyc
%ghost %{python_sitearch}/smart/interfaces/gtk/*.pyo
%{_datadir}/applications/*-smart.desktop
%{_datadir}/pixmaps/smart.png

%{_bindir}/smart-root
%config %{_sysconfdir}/security/console.apps/smart-root
%config %{_sysconfdir}/pam.d/smart-root

%changelog
* Mon Jun 26 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.42-33
- Update to 0.42.
- Remove unneeded patched that have been applied upstream.

* Thu Apr 20 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.41-31
- Add virtual smart-config dependency (#175630 comment 13).

* Tue Apr 11 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.41-30
- Move the disttag to the Release: tag.

* Mon Apr 10 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.41-29
- Fix typos in distro.py, there were %% missing.
- /usr/bin/smart-root should had been %%{_bindir}/smart-root ...
- Make dependent on fedora-package-config-smart.

* Sun Apr  2 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.41-28
- Move usermode support to the gui package.
- Add cluster/gfs *-kernel variants.

* Fri Mar 31 2006 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.41-27
- Sync with specfile from Ville Skyttä <ville.skytta at iki.fi>
- Add empty-description patch (upstream issue 64).
- Update multi-version to include more kernel-* variants.
- Add distro.d support.
- Make owner of %%{_sysconfdir}/smart and %%{_localstatedir}/lib/smart{,/packages,/channels}.

* Wed Dec 21 2005 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.41-26
- Update to 0.41.

* Tue Dec 13 2005 Axel Thimm <Axel.Thimm@ATrpms.net> - 0.40-23
- Adapted to Fedora Extras guidelines for submission.

* Sun Oct  9 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.40.

* Thu Sep 15 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.39.

* Fri Aug 19 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.37.

* Sat Jun 18 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.35.

* Fri Jun 10 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.35.

* Fri Apr  1 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.30.2.

* Fri Mar 25 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.30.

* Wed Mar 16 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.29.2.

* Sat Mar  5 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.29.1.

* Wed Dec 29 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Merge smart and smart-gui src.rpm back together again.
  (all dependencies resolved for all supported platforms)

* Mon Dec 13 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Split out smart-gui and ksmarttray to manage build dependencies better.

* Wed Dec  8 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.28.

* Sun Dec  5 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 0.27.1

* Fri Dec  3 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Initial specfile from Guilherme Manika <guilherme@zorked.net>.
- Some reordering and cleanups.
- Remove binary rpmmodule.so lib.
- Split the gui into a separate package, so the non-gui packages have
  lower requirements.
